using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using System.Runtime.CompilerServices;
using Exferia_Mythos._0_Modelos;
using Exferia_General;
using Exferia_Mythos.General;
using Exferia_EntityFramework;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Mythos._3_Vistas.Listados
{
    public class ABS_Listado_MYT_Protocolos_P_ParteTipo_IncluirRegistros : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MYT_Protocolos_P_ParteTipo_IncluirRegistros()
        {
            RellenarColumnas();
        }

        private void RellenarColumnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Protocolos_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_MYT_Protocolos_Listado_Modelo.id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //Seleccionar
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Protocolos_Listado_Modelo.Seleccionar), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_Protocolos_Listado_Modelo.Seleccionar), "Sel.", G_ENUM_TIPOSDATOS.SELECCIONAR, false, 50, true, true, true, false, "", null, true));

            //codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Protocolos_Listado_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_Protocolos_Listado_Modelo.codigo), "Código", G_ENUM_TIPOSDATOS.LONG_TEXT, false, 90, true, true, true, false, "", null));

            //descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Protocolos_Listado_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_Protocolos_Listado_Modelo.descripcion), "Descripción", G_ENUM_TIPOSDATOS.TEXT, false, 250, true, true, true, false, "", null));

            //ProtocoloTipo
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_PROTOCOLOTIPO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MYT_Protocolos_Listado_Modelo.idProtocoloTipo), nameof(MYT_ProtocolosTipos), nameof(MYT_ProtocolosTipos.id), nameof(MYT_ProtocolosTipos.codigo), nameof(MYT_ProtocolosTipos.descripcion), nameof(MYT_ProtocolosTipos.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Protocolos_Listado_Modelo.ProtocoloTipo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_Protocolos_Listado_Modelo.ProtocoloTipo), "Tipo de protocolo", G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false,true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_PROTOCOLOTIPO));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MYT_PROTOCOLOS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MYT_PROTOCOLOS + "_ParteTipo_I";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_MYT_Protocolos_Listado_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
